#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "../include/getinput.h"

#define TRUE 1
#define FALSE 0

void get_input(prompt, var, type)
char *prompt;
void *var;
enum inputType type;
{
   char answer[80];
   long int l;
   char done;
   do
   {
      done = TRUE;
      printf("%s", prompt);
      gets(answer);
      l = strlen(answer);

      switch(type)
      {
	 case INT :
	    {
	       long int i;
	       if (l == 0) done = FALSE;
	       for(i = 0; i < l; i++)
	       {
		  if(!((answer[i] >= '0' && answer[i] <= '9') ||
		    (answer[i] == '+' || answer[i] == '-' && i == 0)
		    || (answer[i] == ' ' && i == l-1)))
		      done = FALSE;
	       }
	       if(done == TRUE)
	       {
		  long int *j;
		  j = var;
		  *j = atoi(answer);
	       }
	    }
	    break;

	 case POS_INT:
	    {
	       long int i;
	       if (l == 0) done = FALSE;
	       for(i = 0; i < l; i++)
	       {
		  if(!((answer[i] >= '0' && answer[i] <= '9') ||
		    (answer[i] == '+' && i == 0)
		    || (answer[i] == ' ' && i == l-1)))
		       done = FALSE;
	       }
	       if(done == TRUE)
	       {
		  long int *j;
		  j = var;
		  *j = atol(answer);
	       }
	    }
	    break;

	 case NONPOS_INT :
	    {
	       long int i;
	       if (l == 0) done = FALSE;
	       for(i = 0; i < l; i++)
	       {
		  if(!( (answer[0] == '-' || (answer[0] == '0' && l == 1)) &&
		    ( (answer[i] >= '0' && answer[i] <= '9') ||
		    (answer[i] == '-' && i == 0) ) 
		    || (answer[i] == ' ' && i == l-1)))
		      done = FALSE;
	       }
	       if(done == TRUE)
	       {
		  long int *j;
		  j = var;
		  *j = atol(answer);
	       }
	    }
	    break;

	 case NEG_INT:
	    {
	       long int i;
	       if (l == 0) done = FALSE;
	       for(i = 0; i < l; i++)
	       {
		  if(!((answer[i] >= '0' && answer[i] <= '9') &&
		    (answer[0] == '-')
		    || (answer[i] == ' ' && i == l-1)))
		      done = FALSE;
	       }
	       if(done == TRUE)
	       {
		  long int *j;
		  j = var;
		  *j = atoi(answer);
	       }
	    }
	    break;

	 case FLOAT:
	    {
	       long int i, counte = 0, countp=0;
	       if (l == 0) done = FALSE;
	       for(i = 0; i<l; i++)
	       {
		  if(!( (answer[i] >= '0' && answer[i] <= '9') ||
		     (answer[i] == '+' || answer[i] == '-' && i == 0) ||
		     (answer[i] == '.' && countp == 0 && counte == 0) ||
		     (answer[i] == '-' && answer[i-1] == 'e' && i < (l-1)) ||
		     (answer[i] == '+' && answer[i-1] == 'e' && i < (l-1)) ||
		     (answer[i] == 'e' && counte == 0 && i != (l-1))
		     || (answer[i] == ' ' && i == l-1)))
			done = FALSE;

		  if(answer[i] == '.')
		     countp++;
		  if(answer[i] == 'e')
		     counte++;
	       }
	       if(done == TRUE)
	       {
		  double *j;
		  j = var;
		  *j = atof(answer);
	       }
	    }
	    break;

	 case POS_FLOAT:
	    {
	       long int i, counte = 0, countp=0;
	       if (l == 0) done = FALSE;
	       for(i = 0; i<l; i++)
	       {
		  if(!( (answer[i] >= '0' && answer[i] <= '9') ||
		     (answer[i] == '+' && i == 0) ||
		     (answer[i] == '.' && countp == 0 && counte == 0) ||
		     (answer[i] == '-' && answer[i-1] == 'e' && i < (l-1)) ||
		     (answer[i] == '+' && answer[i-1] == 'e' && i < (l-1)) ||
		     (answer[i] == 'e' && counte == 0 && i != (l-1))
		     || (answer[i] == ' ' && i == l-1)))
		       done = FALSE;

		  if(answer[i] == '.')
		     countp++;
		  if(answer[i] == 'e')
		     counte++;
	       }
	       if(done == TRUE)
	       {
		  double *j;
		  j = var;
		  *j = atof(answer);
	       }
	    }
	    break;

	 case NEG_FLOAT:
	    {
	       long int i, counte = 0, countp=0;
	       if (l == 0) done = FALSE;
	       for(i = 0; i<l; i++)
	       {
		  if(!( (answer[0] == '-') &&
		    ( (answer[i] >= '0' && answer[i] < '9') ||
		    (answer[i] == '.' && countp == 0 && counte == 0) ||
		    (answer[i] == '-' && answer[i-1] == 'e' && i < (l-1)) ||
		    (answer[i] == '-' && i == 0) ||
		    (answer[i] == '+' && answer[i-1] == 'e' && i < (l-1)) ||
		    (answer[i] == 'e' && counte == 0 && i != (l-1)) ) 
		     || (answer[i] == ' ' && i == l-1)))
			done = FALSE;

		  if(answer[i] == '.')
		     countp++;
		  if(answer[i] == 'e')
		     counte++;
	       }
	       if(done == TRUE)
	       {
		  double *j;
		  j = var;
		  *j = atof(answer);
	       }
	    }
	    break;

	 case NONPOS_FLOAT:
	    {
	       long int i, counte = 0, countp=0;
	       if (l == 0) done = FALSE;
	       for(i = 0; i<l; i++)
	       {
		  if(!( (answer[0] == '-' || (answer[0] == '0' && l == 1)) &&
		    ( (answer[i] >= '0' && answer[i] <= '9') ||
		    (answer[i] == '.' && countp == 0 && counte == 0) ||
		    (answer[i] == '-' && answer[i-1] == 'e' && i < (l-1)) ||
		    (answer[i] == '-' && i == 0) ||
		    (answer[i] == '+' && answer[i-1] == 'e' && i < (l-1)) ||
		    (answer[i] == 'e' && counte == 0 && i != (l-1))  ) 
		     || (answer[i] == ' ' && i == l-1)))
		      done = FALSE;

		  if(answer[i] == '.')
		     countp++;
		  if(answer[i] == 'e')
		     counte++;
	       }
	       if(done == TRUE)
	       {
		  double *j;
		  j = var;
		  *j = atof(answer);
	       }
	    }
	    break;

	 case STRING:
	    {
	       char *j;
	       j = (char *) malloc(80 * sizeof(char));
	       j = var;
	       strcpy(j, answer);
	    }
	    break;

	 case NAME :
	    {
	       long int i;
	       if (l == 0) done = FALSE;
	       for(i = 0; i < l; i++)
	       {
		  if(answer[i] == ' ' && i != l-1)
		      done = FALSE;
	       }
	       if(done == TRUE)
	       {
		  char *j;
		  j = (char *) malloc(80 * sizeof(char));
		  j = var;
		  strcpy(j, answer);
	       }
	    }
	    break;

	 case CHAR :
	    {
	       long int i;
	       if (l != 1 || answer[0] == ' ') done = FALSE;
	       if(done == TRUE)
	       {
		  char *j;
		  j = var;
		  *j = answer[0];
	       }
	    }
	    break;

	 case YES_NO :
	    {
	       if (!strcasecmp("YES", answer) || !strcasecmp("Y", answer))
	       {
		  char *j;
		  j = var;
		  *j = TRUE;
	       }
	       else if (!strcasecmp("NO", answer) || !strcasecmp("N", answer))
	       {
		  char *j;
		  j = var;
		  *j = FALSE;
	       }
	       else done = FALSE;
	    }
	    break;
      }/* End switch Statement */

      if(done == FALSE)
	 printf("\tInvalid Response.\n");

   } while(done == FALSE);
}/* get_input */

#undef TRUE
#undef FALSE

