#include <stdio.h>
#include <string.h>

#include "../include/header.h"

void write_header(f, sys_type, name, pars, inits,
		  num, tran_len,
		  num_dim, dim_names)
FILE *f;
char sys_type; 
char *name; 
char *pars; 
char *inits;
unsigned long int num; 
unsigned long int tran_len;
unsigned long int num_dim; 
char *dim_names;
{
	int tmp;
	int len, i;


	/**** Fill in header structure ****/

	header.sys_type = sys_type;

	strcpy(header.name, name);
	if ((len = strlen(name)) < NAME_LENGTH)
	{
		for (i = len; i < NAME_LENGTH; i++)
			header.name[i] = ' ';
		header.name[NAME_LENGTH - 1] = 0;
	}

	strcpy(header.pars,pars);
	if ((len = strlen(pars)) < NAME_LENGTH)
	{
		for (i = len; i < NAME_LENGTH; i++)
			header.pars[i] = ' ';
		header.pars[NAME_LENGTH - 1] = 0;
	}

	strcpy(header.inits,inits);
	if ((len = strlen(inits)) < NAME_LENGTH)
	{
		for (i = len; i < NAME_LENGTH; i++)
			header.inits[i] = ' ';
		header.inits[NAME_LENGTH - 1] = 0;
	}

	header.num_pts = num;
	header.tran_len = tran_len;
	header.num_dim = num_dim;
	strcpy(header.dim_names,dim_names);


	/**** Write out header to file ****/

	/* This is essentially a signature to assure correct format */
	fwrite("Map", 1, 3, f);
	fwrite(&header.sys_type, 1, 1, f);
	fwrite(header.name, 1, NAME_LENGTH, f);
	fwrite(header.pars, 1, NAME_LENGTH, f);
	fwrite(header.inits, 1, NAME_LENGTH, f);
	fwrite(&header.num_pts, 4, 1, f);
	fwrite(&header.tran_len, 4, 1, f);
	fwrite(&header.num_dim, 4, 1, f);
	fwrite(header.dim_names, 1, 20, f);


} /* write_header */

int read_header(f)
FILE *f;
{
	char buf[3];

	fread(buf, sizeof(char), 3, f);
	if (strncmp(buf, "Map", 3) != 0)
		return(FILE_FORMAT_ERROR);
	fread(&header.sys_type, 1, 1, f);
	fread(header.name, 1, NAME_LENGTH, f);
	fread(header.pars, 1, NAME_LENGTH, f);
	fread(header.inits, 1, NAME_LENGTH, f);
	fread(&header.num_pts, 4, 1, f);
	if (header.sys_type != SYS_TYPE) swap_long_int(&header.num_pts);

	fread(&header.tran_len, 4, 1, f);
	if (header.sys_type != SYS_TYPE) swap_long_int(&header.tran_len);

	fread(&header.num_dim, 4, 1, f);
	if (header.sys_type != SYS_TYPE) swap_long_int(&header.num_dim);

	fread(header.dim_names, 1, 20, f);

	return(OK);
} /* read_header */


void swap_long_int(data_ptr)
unsigned long int *data_ptr;
/* This routine swaps the bytes of the variable pointed to by 'data_ptr'.
   This is required because UNIX handles thier multiple byte variables
   differently than DOS. */
{
	union {
		unsigned long int num;
		char byte[4];
	      } var;
	char tmp;

	var.num = *data_ptr;
	tmp = var.byte[0];
	var.byte[0] = var.byte[3];
	var.byte[3] = tmp;
	tmp = var.byte[1];
	var.byte[1] = var.byte[2];
	var.byte[2] = tmp;
	*data_ptr = var.num;
} /* swap_long_int */


