/************************************************************************/
/*                                                                      */
/*    Converts Data file in ascii file.					*/
/*                                                                      */
/*                                                                      */
/*    Usage: toascii [input_file_name] [output_file_name]		*/
/*                                                                      */
/*								        */
/************************************************************************/


#define VARS

#include <stdio.h>
#include <math.h>
#include <string.h>
#include "../include/header.h"

#define TRUE 1
#define FALSE 0
#define ALLOCATION_ERROR 2

/**** Global Variables *****/

char file_name[30];             /* File name */
char output_file_name[30];             /* File name */

void get_parameters();
void get_user_input();

void main (argc, argv)
int argc;
char *argv[];
{

   unsigned long int i, count;	       /* Data Counters */
   double data;
   FILE *fd_in, *fd_out;               /* File stream pointer */

   get_parameters(argc, argv);

   if ((fd_in = fopen(file_name,"rb")) == NULL)
   {
      printf("Error Opening File. \n");
      exit(-1);
   }

   if (read_header(fd_in) == FILE_FORMAT_ERROR)
   {
      printf("File %s Does Not Have the Correct Header.  Use createheader.\n"
	      ,file_name);
      exit(-1);
   }

   if ((fd_out = fopen(output_file_name,"wb")) == NULL)
   {
      printf("Error Opening Output File. \n");
      exit(-1);
   }



   for(count = 1; count <= header.num_pts; count++)
   {
      /* fprintf(fd_out, "%ld  ", count); */
      for (i = 1; i <= header.num_dim; i++)
      {
         fread(&data, sizeof(double), 1, fd_in);
         fprintf(fd_out, "%lg ", data);
      }
      fprintf(fd_out, "\n");
   }


   fclose(fd_in);     /* Closes Output Stream */
   fclose(fd_out);

} /* main */


void get_parameters(argc, argv)
int argc;
char *argv[];
/* Gets parameters from either the command line or user input */
{
   int i, count;

   if (argc == 1)
      get_user_input();

   else if (argc != 3)
   {
      /* Incorrect number of arguements.  Exit Program. */
      printf("Usage: toascii [file_name] [output_file_name] \n");
      exit(-1);
   }

   else
   {
      count = 1;
      sprintf(file_name, argv[count++]);
      sprintf(output_file_name, argv[count++]);
   }
}/* get_parameters */


void get_user_input()
/* Gets paramenters from user */
{
   char buf[20];
   int i;

   printf("Enter Input File Name : ");
   scanf("%s", file_name);

   printf("Enter Output File Name : ");
   scanf("%s", output_file_name);

}/* get_user_input */

